/*!
 * MIT License
 *
 * Copyright (c) 2020 Michael Marcenich
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var WorkboxFirebaseAuth=function(){"use strict";const t=()=>new Promise((t,e)=>{const s=firebase.auth().onAuthStateChanged(i=>{s(),i?i.getIdToken(!0).then(e=>{t(e)},()=>{t(null)}).catch(t=>{e(t)}):t(null)})}),e=(t,e)=>{const s=new URL(t.url),i=!e.sameOrigin||self.location.origin===s.origin,r=((t,e)=>{const s=e&&e.split(",").map(t=>t.split(";")[0].trim());return!t||t.includes("*")||!s||s.some(e=>t.includes(e))})(e.types,t.headers.get("accept")),n=!e.https||"https:"===self.location.protocol||"localhost"===self.location.hostname,a=!!e.ignorePaths.length&&e.ignorePaths.some(t=>"string"==typeof t?s.pathname.startsWith(t):t.test(s.pathname));return i&&r&&n&&!a},s=(t,e)=>{const s=new Headers;t.headers.forEach((t,e)=>{s.append(e,t)}),s.append("Authorization","Bearer "+e);const{url:i,...r}=t.clone();return new Request(i,{...r,mode:"same-origin",redirect:"manual",headers:s})};return{initializeFirebase:t=>{const e={version:"7.14.2",...t};e.config?(importScripts(`https://www.gstatic.com/firebasejs/${e.version}/firebase-app.js`),importScripts(`https://www.gstatic.com/firebasejs/${e.version}/firebase-auth.js`),firebase.initializeApp(e.config)):(importScripts(`/__/firebase/${e.version}/firebase-app.js`),importScripts(`/__/firebase/${e.version}/firebase-auth.js`),importScripts("/__/firebase/init.js"))},Plugin:class{constructor(i={}){this.requestWillFetch=async({request:i})=>{if(this.awaitResponse||!e(i,this.constraints))return i;try{const e=await t();return e?s(i,e):i}catch(t){return console.error(t),i}},this.fetchDidSucceed=async({request:i,response:r})=>{if(!this.awaitResponse||401!==r.status||!e(i,this.constraints))return r;try{const e=await t();if(!e)return r;const n=s(i,e);return await fetch(n)}catch(t){return console.error(t),r}},this.awaitResponse=i.awaitResponse||!1;const{types:r,https:n,sameOrigin:a,ignorePaths:o}=i.constraints||{};this.constraints={types:"string"==typeof r?[r]:r||["*"],https:!!n,sameOrigin:"boolean"!=typeof a||a,ignorePaths:o||[]}}}}}();
